#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>

using namespace std;

#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000000000000

ifstream f("olympair.dat");
ofstream g("olympair.sol");

int n,m;
vector<vector<pair<int, long long int> > > a;

void buildBridges(int v1, int v2, int t)
{
	FOR(i,0,a[v1].size()-1)
		a[v2].push_back(make_pair(a[v1][i].first, a[v1][i].second+t));
}

int main()
{
	f >> n >> m;
	a.resize(n);
	int t1, t2, t3, t4;
	vector<long long int> d;
	d.resize(n);
	fill(d.begin(), d.end(), INF);
	d[0] = 0;
	FOR(i,1,m)
	{
		f >> t1 >> t2 >> t3 >> t4;
		t2--;
		t3--;
		if (t1 == 1)
			a[t2].push_back(make_pair(t3, t4));
		else
			buildBridges(t2, t3, t4);
	}
	vector<bool> used(n,false);
	FOR(i,1,n)
	{
		int minx = -1, minn = -1;
		FOR(j, 0, n-1)
			if ((d[j] < minx || minx == -1) && !used[j])
			{
				minx = d[j];
				minn = j;
			}
		used[minn] = true;
		for (int j = 0; j < a[minn].size(); j++)
			d[a[minn][j].first] = min(d[a[minn][j].first], d[minn]+a[minn][j].second);
	}
	FOR(i,1,d.size()-1)
		g << (d[i] != INF ? d[i] : -1) << endl;
	f.close();
	g.close();
	return 0;
}