#pragma comment ( linker, "/STACK:8666685")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <memory.h>
using namespace std;

struct sList
{
	int v;
	unsigned long long d;
	int next;
};
int head[ 2000005 ] = { 0 };
sList list[ 2000005 ];
int k = 0;

void AddEdge( int a, int b, unsigned long long d )
{
	if( a == b )
		return;
	k++;
	list[k].v = b;
	list[k].d = d;
	list[k].next = head[a];
	head[a] = k;
}

int main()
{
	FILE *inf = fopen( "olympair.dat", "r" );
	FILE *outf = fopen( "olympair.sol", "w" );

	int N, M;

	fscanf( inf, "%d %d", &N, &M );

	for( int i = 1; i <= M; i++ )
	{
		unsigned long long T, A, B;
		int C;
		fscanf( inf, "%lld %ld %lld %d", &T, &A, &B, &C );
		if( T == 1 )
		{
			AddEdge( A, B, C );
		}
		else
		{
			int currentEdge = head[ A ];
			while( currentEdge )
			{
				AddEdge( B, list[ currentEdge ].v, list[ currentEdge ].d + C );
				currentEdge = list[ currentEdge ].next;
			}
		}
	}

	unsigned long long dist[ 100005 ];
	bool used[ 100005 ] = { false };
	memset( dist, 63, sizeof( dist ) );
	unsigned long long INF = dist[0];
	dist[1] = 0;

	while( true )
	{
		int currentVertex = 0;
		bool finish = true;
		for( int i = 1; i <= N; i++ )
		{
			if( !used[i] && dist[i] < dist[currentVertex] )
			{
				finish = false;
				currentVertex = i;
			}
		}
		if( finish )
			break;
		used[ currentVertex ] = true;
		int currentEdge = head[currentVertex];
		while( currentEdge )
		{
			if( list[ currentEdge ].d + dist[ currentVertex ] <
				dist[ list[ currentEdge ].v ] )
				dist[ list[ currentEdge ].v ] = list[ currentEdge ].d + dist[ currentVertex ];
			currentEdge = list[ currentEdge ].next;
		}
	}

	for( int i = 2; i <= N; i++ )
	{
		if( dist[i] == INF )
			fprintf( outf, "-1\n" );
		else
			fprintf( outf, "%lld\n", dist[i] );
	}

	fclose( inf );
	fclose( outf );
}
