#pragma comment( linker, "/STACK:333335556" )
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <memory.h>
using namespace std;

struct sEdge
{
	int a;
	int b;
};
sEdge *edges;
int *lump;
int k = 0;

bool cmp( sEdge A, sEdge B )
{
	if( A.a < B.a )
		return true;
	else if( A.a == B.a && A.b < B.b )
		return true;
	else
		return false;
}

void AddEdge( int v, int u )
{
	k++;
	edges[k].a = v;
	edges[k].b = u;
}

int main()
{
	FILE *inf = fopen( "cap.dat", "r" );
	FILE *outf = fopen( "cap.sol", "w" );

	int N, M;

	fscanf( inf, "%d %d", &N, &M );

	char *str = new char[ 1000 ];
	int *v[ 1000 ];
	for( int i = 0; i < N; i++ )
	{
		v[i] = new int[ M ];
		for( int j = 0; j < M; j++ )
			v[i][j] = 0;
	}
	//memset( v, 0, sizeof( v ) );

	int n = 0;
	int s = 0;
	int f = 0;

	for( int i = 0; i < N; i++ )
	{
		fscanf( inf, "%s", str );
		for( int j = 0; j < M; j++ )
		{
			if( str[j] != '.' )
			{
				n++;
				v[ i ][ j ] = n;
			}
			if( str[j] == 'o' )
			{
				s = v[i][j];
			}
			else if( str[j] == '+' )
			{
				f = v[i][j];
			}
		}
	}

	delete [] str;
	edges = new sEdge[ 10000001 ];
	lump = new int[ 1000001 ];

	for( int i = 0; i < N; i++ )
	{
		for( int j = 0; j < M; j++ )
		{
			if( v[i][j] )
			{
				for( int k = i + 1; k < N; k++ )
				{
					if( v[k][j] )
					{
						AddEdge( v[i][j], v[k][j] );
						AddEdge( v[k][j], v[i][j] );
					}
				}

				for( int k = j + 1; k < M; k++ )
				{
					if( v[i][k] )
					{
						AddEdge( v[i][j], v[i][k] );
						AddEdge( v[i][k], v[i][j] );
					}
				}


			}
		}
	}

	for( int i = 0; i < N; i++ )
		delete [] v[i];

	sort( edges + 1, edges + 1 + k, cmp );

	for( int i = k; i >= 1; i-- )
		lump[ edges[i].a ] = i;

	int dist[ 1000001 ];
	bool used[ 1000001 ] = { false };
	memset( dist, 63, sizeof( dist ) );
	int INF = dist[0];
	dist[s] = 0;

	while( true )
	{
		int currentVertex = 0;
		bool finish = true;
		for( int i = 1; i <= n; i++ )
		{
			if( !used[ i ] && dist[i] < dist[ currentVertex ] )
			{
				currentVertex = i;
				finish = false;
			}
		}
		if( finish )
			break;
		used[ currentVertex ] = true;

		for( int i = lump[ currentVertex ]; i <= k; i++ )
		{
			if( edges[i].a != currentVertex )
				break;
			if( !used[ edges[i].b ] && dist[currentVertex] + 1 < dist[ edges[i].b ] )
				dist[ edges[i].b ] = dist[currentVertex] + 1;
		}
	}

	if( dist[f] != INF )
		fprintf( outf, "%d\n", dist[f] );
	else
		fprintf( outf, "-1\n" );

	fclose( inf );
	fclose( outf );
	exit( 0 );
}
