#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cmath>
#include <set>
#include <map>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 100000;

int a[MaxN];
int f[MaxN];

bool used[MaxN];

vector<int> wh[MaxN];

int Sz[MaxN], now[MaxN];

int n;

void add(int x) {
	int now = x;
	while (now < n) {
		f[now]++;
		now = now | (now+1);
	}
}

int sum (int n) {
	if (n == -1) return 0;
	int res = 0;
	for (n; n >= 0; n = (n & (n+1))-1)
		res += f[n];
	return res;
}

int sum (int l, int r) {
	return sum(r) - sum(l-1);
}

int main () {
	freopen ("mutation.dat", "r", stdin);
	freopen ("mutation.sol", "w", stdout);
	int x;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++) {
		f[i] = 0;
		used[i] = false;
	}
	for (int i = 0; i < n; i++) {
		scanf ("%d", &x);
		x--;
		a[i]=x;
		Sz[x]++;
	}
	if (n <= 16) {
		bool used[20];
		int result = 0;
		for (int i = 0; i < n; i++)
			used[i] = false;
		while (true) {
			int ch = -1;
			int len = -1;
			for (int i = 0; i < n; i++) 
				if (!used[i]) {
					int num = a[i];
					int l = i, r = i;
					for (int j = i; j >= 0; j--)
						if (a[j] == num) l = j;
					for (int j = i; j < n; j++)
						if (a[j] == num) r = j;
					int howM = 0;
					for (int i = l+1; i <= r-1; i++)
						if (a[i] != num && !used[i]) howM++;
					if (len < howM) {
						len = howM;
						ch = i;
					}
				}
			if (ch == -1)
				break;
			if (len == 0) break;
			result++;
			for (int i = 0; i < n; i++)
				if (a[i] == a[ch]) 
					used[i] = true;
		}
		cout << result;
		return 0;
	}
	for (int i = 0; i < n; i++) {
		wh[i].resize(Sz[i]);
		now[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		int x = a[i];
		wh[x][now[x]++] = i;
	}
	int i = 0;
	int result = 0;
	int t;
	while (i < n) {
		while (i < n && used[i]) i++;
		if (i >= n) break;
		int elem = a[i];
		int lastElem = wh[elem].back();
		int sz = (int)wh[elem].size();
		int Sum = sum(i, lastElem);
		if (sz != lastElem-i+1-Sum) result++;
		for (int j = 0; j < sz; j++) {
			t = wh[elem][j];
			used[t] = true;
			add(t);
		}
	}
	cout << result;
}