#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "cap"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;
const int wssign = 8542354;

int n, m, st_r, st_c, en_r, en_c;
int was[MAX_N][MAX_N];
list<int> rowssign[MAX_N], cols[MAX_N];
list<int>::iterator iter;
queue< pair< pair<int, int>, int> > pos;
int sz;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);


    char ch;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            scanf("%c", &ch);
            switch (ch) {
                case 'x': {
                    rowssign[i].push_back(j);
                    cols[j].push_back(i);
                } break;
                case 'o': {
                    st_r = i;
                    st_c = j;
                } break;
                case '+': {
                    en_r = i;
                    en_c = j;
                    rowssign[i].push_back(j);
                    cols[j].push_back(i);
                } break;
            }
        }
        scanf("\n");
    }

    pos.push(make_pair(make_pair(st_r, st_c), 0));
    sz = 1;

    pair< pair<int, int>, int> pr; int row, col, step;
    while (sz) {
        pr = pos.front();
        row = pr.first.first;
        col = pr.first.second;
        step = pr.second;
        pos.pop();
        --sz;

        was[row][col] = wssign;

        //cout << '!' << row << ' ' << col << endl;

        if (row == en_r && col == en_c) {
            printf("%d", step);
            exit(0);
        }

        if (row == en_r || col == en_c) {
            printf("%d", (step + 1));
            exit(0);
        }

        for (iter = rowssign[row].begin(); iter != rowssign[row].end(); ++iter) {
            if (was[row][(*iter)] != wssign) {
                pos.push(make_pair(make_pair(row, (*iter)), step + 1));
                ++sz;
            }
        }
        rowssign[row].clear();

        for (iter = cols[col].begin(); iter != cols[col].end(); ++iter) {
            if (was[*iter][col] != wssign) {
                pos.push(make_pair(make_pair((*iter), col), step + 1));
                ++sz;
            }
        }
        cols[col].clear();
    }

    printf("-1");

    return 0;
}
