#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "cap"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, m, st_r, st_c, en_r, en_c, i, j;
queue<int> rows[MAX_N], cols[MAX_N];
queue< pair< pair<int, int>, int> > pos;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);

    char ch;
    for (i = 0; i < n; ++i) {
        for (j = 0; j < m; ++j) {
            scanf("%c", &ch);
            switch (ch) {
                case 'x': {
                    rows[i].push(j);
                    cols[j].push(i);
                } break;
                case 'o': {
                    st_r = i;
                    st_c = j;
                } break;
                case '+': {
                    en_r = i;
                    en_c = j;
                    rows[i].push(j);
                    cols[j].push(i);
                } break;
            }
        }
        scanf("\n");
    }

    pos.push(make_pair(make_pair(st_r, st_c), 0));

    pair< pair<int, int>, int> pr; int row, col, step, cr;
    while (!pos.empty()) {
        pr = pos.front();
        row = pr.first.first;
        col = pr.first.second;
        step = pr.second;
        pos.pop();

        //cout << '!' << row << ' ' << col << endl;

        if (row == en_r && col == en_c) {
            printf("%d", step);
            exit(0);
        }

        if (row == en_r || col == en_c) {
            printf("%d", step + 1);
            exit(0);
        }

        while (!rows[row].empty()) {
            cr = rows[row].front();
            rows[row].pop();
            pos.push(make_pair(make_pair(row, cr), step));
        }


        while (!cols[col].empty()) {
            cr = cols[col].front();
            cols[col].pop();
            pos.push(make_pair(make_pair(cr, col), step));
        }
    }

    printf("-1");

    return 0;
}
