#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "tetris"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, res;
vector<int> a, b;
map< vector<int>, int > steps;

bool eq(const vector<int> & a) {
    //cout << "EQ" << endl;
    for (int i = 0; i < n; ++i) {
        //cout << "EQ: " << a[i] << ' ' << b[i] << endl;
        if (a[i] != b[i]) return false;
    }

    return true;
}

void dfs(vector<int> a, int step) {

    if (steps.count(a)) {
        if (steps[a] > step) {
            steps[a] = step;
        } else {
            return;
        }
    } else {
        steps[a] = step;
    }

    if (eq(a)) {
        res = min(res, step);
        return;
    }

    //cout << 'H' << endl;

    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            ++a[i];

            if (a[i] == 4) a[i] = 0;

            dfs(a, step + 1);
        }

        for (int j = (n - 1); j >= i; --j) {
            --a[i];

            if (a[i] == -1) a[i] = 3;
        }
    }
}

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n;
    a.resize(n);
    b.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < n; ++i)
        cin >> b[i];

    res = inf;
    dfs(a, 0);

    cout << res;

    return 0;
}
