#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>
#include <cmath>

using namespace std;

#define problem "camelot"

typedef set<int>::iterator itr;

const int MAX_N = 35000;
const long long inf = (long long) 1e18;

int n, m, k, i, j, x, y, l;
int fort_x[MAX_N], fort_y[MAX_N], fort_r[MAX_N], fort_c[MAX_N], knight[MAX_N];
set<int> fort_inl[MAX_N], knight_inl[MAX_N];
itr iter;

inline long double dist(long long x1, long long y1, long long x2, long long y2) {
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n >> m >> k;

    for (i = 0; i < n; ++i) {
        cin >> fort_x[i] >> fort_y[i] >> fort_r[i] >> fort_c[i];
    }

    for (i = 0; i < n; ++i) {
        for (j = 0; j < n; ++j) {
            if (i != j && dist(fort_x[i], fort_y[i], fort_x[j], fort_y[j]) <= fort_r[i]) {
                fort_inl[j].insert(i);
            }
        }
    }

    for (i = 0; i < m; ++i) {
        cin >> x >> y >> l;

        knight[i] = l;

        for (j = 0; j < n; ++j) {
            if (dist(x, y, fort_x[j], fort_y[j]) <= fort_r[j])
                knight_inl[i].insert(j);
        }
    }

    //fort_c[2] = 0;

    long long res = inf, path;
    for (i = 0; i < n; ++i) {
        path = 0;
        //cout << endl;
        for (j = 0; j < m; ++j) {
            for (iter = knight_inl[j].begin(); iter != knight_inl[j].end(); ++iter) {
                if ((*iter != i) && !fort_inl[i].count(*iter)) {
                    path += knight[j] * fort_c[*iter];
                    //cout << "   HO" << (*iter) << ' ' << j << endl;
                }
            }

            if (!knight_inl[j].count(i)) {
                path += knight[j] * fort_c[i];
                //cout << "   HC" << j << endl;
            }

            for (iter = fort_inl[i].begin(); iter != fort_inl[i].end(); ++iter) {
                if ((*iter != i) && !knight_inl[j].count(*iter)) {
                    path += knight[j] * fort_c[*iter];
                    //cout << "   HOK" << (*iter) << ' ' << j << endl;
                }
            }
        }

        //cout << i << ' ' << path << endl;

        res = min(res, path);
    }


    cout << res;

    return 0;
}
