#include <iostream>
#include <stdio.h>
#include <queue>

using namespace std;

const int Max = 200010;
const int Max2 = 262144;

struct TRec {
    int v;
    int a;
};

TRec tr[Max2] = {{0}};

int Full(int n) {
    bool full = true;
    int c = 0;

    while (n > 1) {
        ++c;

        if (n % 2 == 1) {
            full = false;
        }
        n /= 2;
    }

    if (!full) {
        ++c;
    }

    return (1 << c);
}

int Up(int a) {
    return (a - 1) / 2;
}

int Left(int a) {
    return (a * 2 + 1);
}

int Right(int a) {
    return (a * 2 + 2);
}

void Set(TRec* tr, int nf, int a, int v) {
    int i = a + nf - 1;

    tr[i].a = a;
    tr[i].v = v;

    while (i > 0) {
        int up = Up(i);
        int l = Left(up);
        int r = l + 1;

        if (tr[l].v > tr[r].v) {
            tr[up] = tr[l];
        } else {
            tr[up] = tr[r];
        }

        i = Up(i);
    }
}

int main() {
    FILE* fin = fopen("stones.dat", "r");
    FILE* fout = fopen("stones.sol", "w");

    int n;
    int m;
    fscanf(fin, "%d%d", &n, &m);

    priority_queue<int>* map = new priority_queue<int>[m];

    int nf = Full(m);

    for (int i = 0; i < m; ++i) {
        tr[i + nf - 1].v = 0;
        tr[i + nf - 1].a = i;
    }

    for (int i = 0; i < n; ++i) {
        int cmd;
        fscanf(fin, "%d", &cmd);

        if (cmd == 1) {
            int a;
            int v;
            fscanf(fin, "%d%d", &a, &v);
            --a;

            if (map[a].empty() || (v < -map[a].top())) {
                Set(tr, nf, a, v);
            }

            map[a].push(-v);
        } else {
            fprintf(fout, "%d\n", tr[0].v);
            map[tr[0].a].pop();

            Set(tr, nf, tr[0].a, -map[tr[0].a].top());
        }
    }

    fclose(fin);
    fclose(fout);

    return 0;
}
