//#include <iostream>
#include <stdio.h>
#include <queue>

using namespace std;

const int Max = 1010;
const int Inf = 1234567890;

int Map[Max][Max];

int main() {
    FILE* f = fopen("cap.dat", "r");

    int n;
    int m;
    fscanf(f, "%d%d", &n, &m);

    queue< pair<int, int> > q;

    pair<int, int> fn;

    for (int i = 0; i < n; ++i) {
        char str[Max];
        fscanf(f, "%s", str);

        for (int j = 0; j < m; ++j) {
            char chr = str[j];

            if (chr == '.') {
                Map[i][j] = -1;
            } else {
                Map[i][j] = Inf;

                if (chr == 'o') {
                    q.push(make_pair(i, j));
                    Map[i][j] = 0;
                }
                if (chr == '+') {
                    fn = make_pair(i, j);
                }
            }
        }
    }

    fclose(f);

    bool yUsed[Max] = {false};
    bool xUsed[Max] = {false};

    while (!q.empty() && (q.front() != fn)) {
        int y = q.front().first;
        int x = q.front().second;
        q.pop();

        //cout << "c: " << y << " " << x << endl;

        int nt = Map[y][x] + 1;

        if (!xUsed[x]) {
            xUsed[x] = true;

            for (int i = 0; i < n; ++i) {
                if (Map[i][x] == Inf) {
                    Map[i][x] = nt;
                    q.push(make_pair(i, x));
                }
            }
        }

        if (!yUsed[y]) {
            yUsed[y] = true;

            for (int j = 0; j < m; ++j) {
                if (Map[y][j] == Inf) {
                    Map[y][j] = nt;
                    q.push(make_pair(y, j));
                }
            }
        }
    }

    int res = Map[fn.first][fn.second];
    if (res == Inf) {
        res = -1;
    }

    /*
    cout << endl;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << Map[i][j] << " ";
        }
        cout << endl;
    }
    */

    f = fopen("cap.sol", "w");

    fprintf(f, "%d\n", res);
    fclose(f);

    return 0;
}




