#include <iostream>
#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long int ll;

struct Cst {
    ll x;
    ll y;
    ll r;
    ll p;
};

struct Kn {
    ll x;
    ll y;
    ll c;
};

ll Len2(ll x1, ll y1, ll x2, ll y2) {
    x2 -= x1;
    y2 -= y1;

    return (x2 * x2 + y2 * y2);
}

int main() {
    FILE* f = fopen("camelot.dat", "r");

    int n;
    int m;
    int k;
    fscanf(f, "%d%d%d", &n, &m, &k);

    Cst cst[1000];
    Kn kn[1000];

    for (int i = 0; i < n; ++i) {
        int x;
        int y;
        int r;
        int p;
        fscanf(f, "%d%d%d%d", &x, &y, &r, &p);

        cst[i].x = x;
        cst[i].y = y;
        cst[i].r = r;
        cst[i].p = p;
    }

    for (int i = 0; i < m; ++i) {
        int x;
        int y;
        int c;
        fscanf(f, "%d%d%d", &x, &y, &c);

        kn[i].x = x;
        kn[i].y = y;
        kn[i].c = c;
    }

    fclose(f);

    int kh[1000];

    for (int i = 0; i < m; ++i) {
        kh[i] = -1;

        for (int j = 0; j < n; ++j) {
            if (Len2(kn[i].x, kn[i].y, cst[j].x, cst[j].y) < (ll)cst[j].r * cst[j].r) {
                kh[i] = j;
            }
        }
    }

    cout << kh[2] << endl;

    ll res = 1234567890123456;
    for (int i = 0; i < n; ++i) {
        ll p[1000] = {0};

        for (int j = 0; j < m; ++j) {
            int h = kh[j];

            if ((h >= 0) && (h != i)) {
                p[h] += kn[j].c * cst[h].p;
            }
            if (h != i) {
                p[i] += kn[j].c * cst[i].p;
            }
        }

        sort(p, &p[n]);

        ll r = 0;
        for (int j = 0; j < n - k; ++j) {
            r += p[j];
        }

        res = min(r, res);
    }

    cout << res << endl;

    f = fopen("camelot.sol", "w");

    fprintf(f, "%lld\n", res);
    fclose(f);

    return 0;
}
