#include <iostream>
#include <stdio.h>
#include <vector>
#include <map>
using namespace std;

class Reis {
    public:
    Reis() {
        to = -1;
    }
    long to;
    long time;
};

vector< map<long, Reis> > graph;
vector<bool> used;
vector<long> priceArr;

void dfs(int i, int priceAll, int price) {
    //cout << "i" << i << " priceAll " << priceAll << " price " << price << endl;
    priceAll += price;
    long pr = priceArr[i];
    if(pr > priceAll || pr == -1)
        priceArr[i] = priceAll;

    if(used[i])
        return;

    used[i] = true;
    for(map<long, Reis>::iterator it = graph[i].begin(); it != graph[i].end(); it++) {
        pair<long, Reis> r = *it;
        //cout << "reis s " << i << " to" << r.second.to << " cena " << r.second.time << endl;
        dfs(r.second.to, priceAll, r.second.time);
    }
}

void createReis(int a, int b, int c) {
    map<long, Reis>::iterator it = graph[a].find(b);

    if(it != graph[a].end()) {
        Reis* r = &(*it).second;
        if(r->time > c)
            r->time = c;
    } else {
        Reis r;
        r.to = b;
        r.time = c;
        graph[a][b] = r;
    }
}

int main()
{
    freopen("olympair.dat", "r",  stdin);
    freopen("olympair.sol", "w", stdout);

    long n, m;
    cin >> n >> m;

    used.resize(n);
    graph.resize(n);

    priceArr.resize(n, -1);

    for(int i = 0; i < m; i++) {
        long type,a,b,c;
        cin >> type >> a >> b >> c;
        a--;
        b--;
        if(type == 1) {
            createReis(a, b, c);
        } else {
             for(map<long, Reis>::iterator it = graph[a].begin(); it != graph[a].end(); it++) {
                pair<long, Reis> r = *it;
                createReis(b, r.second.to, r.second.time + c);
            }
        }
    }

    dfs(0, 0, 0);

    for(int i = 1; i < n; i++)
        cout << priceArr[i] << endl;

    return 0;
}
