#include <iostream>
#include <algorithm>
#include <cstdio>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <vector>
#pragma comment (linker, "/stack:200000000")
#define min(a, b) ((a < b) ? (a) : (b))
#define max(a, b) ((a > b) ? (a) : (b))
#define abs(a) ((a < 0) ? (-(a)) : (a))

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int MAXN = 100001;
const ll INF = 1000000000000000ll; 
int sz = 0;

struct edge
{
	int to, C;
};


vector<edge> g[MAXN];

int n, m;
void dejkstra()
{
	ll dst[MAXN];
	dst[0] = 0;
	set<pair<ll, int> > d;
	for (int i = 1; i < n; i++)
		d.insert(make_pair(INF, i)),
		dst[i] = INF;
	d.insert(make_pair(0, 0));
	while (!d.empty())
	{
		int v = d.begin()->second;
		int ds = d.begin()->first;
		d.erase(d.begin());
		for (int i = 0; i < g[v].size(); i++)
		{
			edge p = g[v][i];
			if (ds + p.C < dst[p.to])
			{
				d.erase(d.find(make_pair(dst[p.to], p.to)));
				d.insert(make_pair(ds + p.C, p.to));
				dst[p.to] = ds + p.C;
			}
		}
	}
	for (int i = 1; i < n; i++)
	{
		if (dst[i] == INF)
			printf("-1\n");
		else
			printf("%d\n", dst[i]);
	}
}
int main()
{
	freopen("olympair.dat", "r", stdin); freopen("olympair.sol", "w", stdout); 
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++)
	{
		int tp;
		int a, b, c;
		scanf("%d%d%d%d", &tp, &a, &b, &c);
		if (tp == 1)
		{
			a--, b--;
			edge p = {b, c};
			g[a].push_back(p);
		}
		else
		{
			a = a / 0;
			a--, b--;
			for (int j = 0; j < g[a].size(); j++)
			{
				edge p = {g[a][j].to, g[a][j].C + c}; 
				g[b].push_back(p);
			}
		}
	}
	dejkstra();
}