#include <iostream>
#include <algorithm>
#include <cstdio>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <vector>
#pragma comment (linker, "/stack:200000000")
#define min(a, b) ((a < b) ? (a) : (b))
#define max(a, b) ((a > b) ? (a) : (b))
#define abs(a) ((a < 0) ? (-(a)) : (a))

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int MAXN = 10001;
const ll INF = 1000000000000000ll; 

vector<int> g[MAXN][2];

int n, m;
void dejkstra()
{
	ll dst[MAXN];
	dst[0] = 0;
	set< pair<ll, int> > d;
	for (int i = 1; i < n; i++)
		d.insert(make_pair(INF, i)),
		dst[i] = INF;
	d.insert(make_pair(0, 0));
	while (!d.empty())
	{
		int v = d.begin()->second;
		int ds = d.begin()->first;
		d.erase(d.begin());
		for (int i = 0; i < g[v][0].size(); i++)
		{
			int pC = g[v][1][i],
				pto = g[v][0][i];
			if (ds + pC < dst[pto])
			{
				d.erase(d.find(make_pair(dst[pto], pto)));
				d.insert(make_pair(ds + pC, pto));
				dst[pto] = ds + pC;
			}
		}
	}
	for (int i = 1; i < n; i++)
	{
		if (dst[i] == INF)
			printf("-1\n");
		else
			printf("%d\n", dst[i]);
	}
}
int main()
{
	freopen("olympair.dat", "r", stdin); freopen("olympair.sol", "w", stdout); 
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++)
	{
		int tp;
		int a, b, c;
		scanf("%d%d%d%d", &tp, &a, &b, &c);
		if (tp == 1)
		{
			a--, b--;
			g[a][0].push_back(b);
			g[a][1].push_back(c);
		}
		else
		{
			a--, b--;
			for (int j = 0; j < g[a][0].size(); j++)
			{
				g[b][0].push_back(g[a][0][j]);
				g[b][1].push_back(g[a][1][j] + c);
			}
		}
	}
	dejkstra();
}