#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define task_name "cap"

using namespace std;

struct point{
    int x;
    int y;
};

point start,finish;
bool matrix[1001][1001];
point q_list[10001];
int q_length[10001];
int head=1,tail=0;
int n,m;

int bfs() {
    while(head > tail) {
        matrix[q_list[tail].x][q_list[tail].y] = false;
        //cout << head << " " << tail << " - " << q_list[tail].x << ";" << q_list[tail].y << endl;
        if(q_list[tail].x == finish.x && q_list[tail].y == finish.y) {
            //cout << "end = " << q_list[tail].x << ";" << q_list[head].y << endl;
            return q_length[tail]-1;
        }
        if(q_list[tail].x-1 >= 0 && (matrix[q_list[tail].x-1][q_list[tail].y])) {
            q_list[head].x = q_list[tail].x-1;
            q_list[head].y = q_list[tail].y;
            q_length[head] = q_length[tail]+1;
            head++;
        }
        if(q_list[tail].x+1 < n && (matrix[q_list[tail].x+1][q_list[tail].y])) {
            q_list[head].x = q_list[tail].x+1;
            q_list[head].y = q_list[tail].y;
            q_length[head] = q_length[tail]+1;
            head++;
        }
        if(q_list[tail].y-1 >= 0 && (matrix[q_list[tail].x][q_list[tail].y-1])) {
            q_list[head].x = q_list[tail].x;
            q_list[head].y = q_list[tail].y-1;
            q_length[head] = q_length[tail]+1;
            head++;
        }
        if(q_list[tail].x+1 < m && (matrix[q_list[tail].x][q_list[tail].y+1])) {
            q_list[head].x = q_list[tail].x;
            q_list[head].y = q_list[tail].y+1;
            q_length[head] = q_length[tail]+1;
            head++;
        }
        tail++;
    }
    return -1;
}

int main() {

	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    char tmp;
    inp >> n >> m;

    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            inp >> tmp;
            if(tmp == '.')
                matrix[i][j] = false;
            if(tmp == 'x' || tmp == 'o' || tmp == '+')
                matrix[i][j] = true;
            if(tmp == 'o') {
                start.x = i;
                start.y = j;
                //cout << "start = " << i << ";" << j << endl;
            }
            if(tmp == '+') {
                finish.x = i;
                finish.y = j;
                //cout << "finish = " << i << ";" << j << endl;
            }
        }
    }

    q_list[0].x = start.x;
    q_list[0].y = start.y;
    //cout << q_list[0].x << ";" << q_list[0].y << endl;
    q_length[0] = 0;
    out << bfs() << endl;

	inp.close();
	out.close();

}
