#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define task_name "cap"

using namespace std;

struct point{
    int x;
    int y;
};

point start,finish;
int matrix[1001][1001];
point q_list[1000000];
int q_length[1000000];
int head=1,tail=0;
int n,m;

int bfs() {
    while(head != tail) {
        //cout << head << " " << tail << " - " << q_list[tail].x << ";" << q_list[tail].y << endl;
        if(q_list[tail].x == finish.x && q_list[tail].y == finish.y) {
            //cout << "end = " << q_list[tail].x << ";" << q_list[tail].y << endl;
            return q_length[tail];
        }

        for(int i=1;i<n;i++) {
            if(q_list[tail].x-i >= 0 && (matrix[q_list[tail].x-i][q_list[tail].y] != -1)) {
                q_list[head].x = q_list[tail].x-i;
                q_list[head].y = q_list[tail].y;
                matrix[q_list[head].x][q_list[head].y] = -1;
                q_length[head] = q_length[tail]+1;
                head++;
            }
            if(q_list[tail].x+i < n && (matrix[q_list[tail].x+i][q_list[tail].y] != -1)) {
                q_list[head].x = q_list[tail].x+i;
                q_list[head].y = q_list[tail].y;
                matrix[q_list[head].x][q_list[head].y] = -1;
                q_length[head] = q_length[tail]+1;
                head++;
            }
        }
        for(int i=1;i<m;i++) {
            if(q_list[tail].y-i >= 0 && (matrix[q_list[tail].x][q_list[tail].y-i] != -1)) {
                q_list[head].x = q_list[tail].x;
                q_list[head].y = q_list[tail].y-i;
                matrix[q_list[head].x][q_list[head].y] = -1;
                q_length[head] = q_length[tail]+1;
                head++;
            }
            if(q_list[tail].y+i < m && (matrix[q_list[tail].x][q_list[tail].y+i] != -1)) {
                q_list[head].x = q_list[tail].x;
                q_list[head].y = q_list[tail].y+i;
                matrix[q_list[head].x][q_list[head].y] = -1;
                q_length[head] = q_length[tail]+1;
                head++;
            }
        }
        tail++;
    }
    return -1;
}

void brush(int x,int y) {
    int i=x+1,j=y;
    while(matrix[i][j] != -1 && i<n) {
        if(matrix[i][j] == 0 || matrix[i][j] > matrix[x][y]+1) {
            matrix[i][j] = matrix[x][y]+1;
            brush(i,j);
        }
        i++;
    }
    i=x-1;
    while(matrix[i][j] != -1 && i>=0) {
        if(matrix[i][j] == 0 || matrix[i][j] > matrix[x][y]+1) {
            matrix[i][j] = matrix[x][y]+1;
            brush(i,j);
        }
        i--;
    }
    i=x;
    j=y+1;
    while(matrix[i][j] != -1 && j<m) {
        if(matrix[i][j] == 0 || matrix[i][j] > matrix[x][y]+1) {
            matrix[i][j] = matrix[x][y]+1;
            brush(i,j);
        }
        j++;
    }
    j=y-1;
    while(matrix[i][j] != -1 && j>=0) {
        if(matrix[i][j] == 0 || matrix[i][j] > matrix[x][y]+1) {
            matrix[i][j] = matrix[x][y]+1;
            brush(i,j);
        }
        j--;
    }
}

int main() {

	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    char tmp;
    inp >> n >> m;

    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            inp >> tmp;
            if(tmp == '.')
                matrix[i][j] = -1;
            if(tmp == 'x' || tmp == 'o' || tmp == '+')
                matrix[i][j] = 0;
            if(tmp == 'o') {
                start.x = i;
                start.y = j;
            }
            if(tmp == '+') {
                finish.x = i;
                finish.y = j;
            }
        }
    }

    q_list[0].x = start.x;
    q_list[0].y = start.y;
    q_length[0] = 0;
    //out << bfs() << endl;

    brush(start.x,start.y);
    out << (matrix[finish.x][finish.y] == 0 ? -1 : matrix[finish.x][finish.y]-1) << endl;

	inp.close();
	out.close();

}
