#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <string>
#include <cstdio>
#include <cmath>
#include <climits>

using namespace std;

vector< pair<int, int> > A[100000];

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);

	int n, m, a, b, c, t;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; ++i)
	{
		scanf("%d %d %d %d", &t, &a, &b, &c);
		--a, --b;
		if (t == 1)
			A[a].push_back(make_pair(b, c));
		else for (size_t j = 0; j < A[a].size(); ++j)
			if (A[a][j].first != b)
				A[b].push_back(make_pair(A[a][j].first, A[a][j].second + c));
	}

	bool looked[100000] = {};
	long long d[100000];
	set<pair<long long, int> > S;
	for (int i = 1; i < n; ++i)
		d[i] = LLONG_MAX;
	d[0] = 0;
	S.insert(make_pair(d[0], 0));

	while (!S.empty())
	{
		int cur = S.begin() -> second;
		looked[cur] = true;
		S.erase(S.begin());

		for (size_t i = 0; i < A[cur].size(); ++i)
			if (!looked[A[cur][i].first])
			{
				int to = A[cur][i].first;
				long long w = A[cur][i].second;
				if (d[cur] + w < d[to])
				{
					S.erase(make_pair(d[to], to));
					d[to] = d[cur] + w;
					S.insert(make_pair(d[to], to));
				}
			}
	}

	for (int i = 1; i < n; ++i)
		if (d[i] != LLONG_MAX)
			printf("%lld\n", d[i]);
		else
			printf("-1\n");

	return 0;
}
