#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <string>
#include <cstdio>
#include <cmath>
#include <climits>

using namespace std;

vector< map<int, long long> > A;

/*void printm()
{
	for (size_t i = 0; i < A.size(); ++i)
	{
		printf("%d: ", i + 1);
		for (map<int, int>::iterator it = A[i].begin(); it != A[i].end(); ++it)
			printf("(%d : %d) ", it->first, it->second);
		printf("\n");
	}
}*/

void update(int from, int to, long long neww)
{
	if (from == to)
		return;
	map<int, long long>::iterator it = A[from].find(to);
	if (it != A[from].end())
		A[from][to] = min(A[from][to], neww);
	else
		A[from][to] = neww;
}

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);

	int n, m, a, b, c, t;
	scanf("%d %d", &n, &m);
	A.resize(n);
	for (int i = 0; i < m; ++i)
	{
		scanf("%d %d %d %d", &t, &a, &b, &c);
		--a, --b;
		if (t == 1)
			update(a, b, c);
		else for (map<int, long long>::iterator it = A[a].begin(); it != A[a].end(); ++it)
			update(b, it->first, it->second + c);
	}

	bool looked[100000] = {};
	long long d[100000];
	set<pair<long long, int> > S;
	for (int i = 1; i < n; ++i)
		d[i] = LLONG_MAX;
	d[0] = 0;
	S.insert(make_pair(d[0], 0));

	while (!S.empty())
	{
		int cur = S.begin() -> second;
		looked[cur] = true;
		S.erase(S.begin());

		for (map<int, long long>::iterator it = A[cur].begin(); it != A[cur].end(); ++it)
			if (!looked[it->first])
				if (d[cur] + it->second < d[it->first])
				{
					S.erase(make_pair(d[it->first], it->first));
					d[it->first] = d[cur] + it->second;
					S.insert(make_pair(d[it->first], it->first));
				}
	}

	for (int i = 1; i < n; ++i)
		if (d[i] != LLONG_MAX)
			printf("%Ld\n", d[i]);
		else
			printf("-1\n");

	return 0;
}
