#include <iostream>
#include <fstream>
#include <map>
#include <vector>
#include <queue>

using namespace std;

typedef map<int, int> node; // <child, weight>

node **conv;

int n, m;

#define C(X) (*(conv[(X)]))

int main()
{
	ifstream in("olympair.dat");
	ofstream out("olympair.sol");

	in >> n >> m;

	conv = new node*[n];
	for (int i = 0; i < n; i++) {
		conv[i] = new node;
	}

	for (int i = 0; i < m; i++) {
		int op, a, b, c;
		in >> op >> a >> b >> c;
		a--, b--;
		if (op == 1) {
			C(a)[b] = c;
		} else {
			node A = C(a);
			for (node::iterator j = A.begin(); j != A.end(); j++) {
				C(b)[j->first] = j->second + c;
			}
		}
	}

	char *visited = new char[n];
	memset(visited, 0, n);
	int *len = new int[n];
	memset(len, 0x77777777, n * sizeof(int));
	len[0] = 0;
	queue<int> head;
	head.push(0);
	while(head.size() > 0) {
		int x = head.front();
		node n = C(x);
		head.pop();
		for (node::iterator i = n.begin(); i != n.end(); i++) {
			if (len[i->first] > len[x] + i->second) {
				len[i->first] = len[x] + i->second;
			}
			head.push(i->first);
		}
	}

	for (int i = 1; i < n; i++) {
		out << (len[i] == 0x77777777 ? -1 : len[i]) << endl;
	}
	
	return 0;
}