#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
using namespace std;

#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef pair<int,int> pii;

const int maxn = 1024;
const ll inf = (ll)1e15;

#define task "cap"

int n,m,dx[] = {0,0,-1,1}, dy[] = {1,-1,0,0}, enx, eny, stx, sty;
ll  d[maxn][maxn];
char s[maxn][maxn];

#define x second
#define y first

int main(){
  #ifdef DEBUG
  freopen("input.txt","r",stdin);
  freopen("output.txt","w",stdout);
  #else
  freopen(task".dat","r",stdin);
  freopen(task".sol","w",stdout);
  #endif
  ll ddx[maxn], ddy[maxn];
  cin >> n >> m;
  for (int i=0;i<n;++i)
    for (int j=0;j<m;++j){
      d[i][j] = inf;
      ddx[j] = inf;
      ddy[i] = inf;
      cin >> s[i][j];
      if (s[i][j]=='o'){
        stx = j;
        sty = i;
      }
      if (s[i][j]=='+'){
        enx = j;
        eny = i;
      }
    }

  queue<pii> q;
  q.push(mp(sty,stx));
  d[sty][stx] = 0;
  ddx[stx] = 1;
  ddy[sty] = 1;
  while (!q.empty()){
    pii v = q.front();
    q.pop();
    for (int i=0;i<4;++i){
      if (v.x+dx[i]<m && v.x+dx[i]>=0 && v.y+dy[i]<n && v.y+dy[i]>=0 && (ddx[v.x+dx[i]]>ddx[v.x]+1 || ddy[v.y+dy[i]]>ddy[v.y]+1 || d[v.y+dy[i]][v.x+dx[i]]>d[v.y][v.x]+1) && s[v.y+dy[i]][v.x+dx[i]]!='.'){
          ddx[v.x+dx[i]] = min(min(ddx[v.x],min(ddy[v.y],d[v.y][v.x]))+1,ddx[v.x+dx[i]]);
          ddy[v.y+dy[i]] = min(min(ddx[v.x],min(ddy[v.y],d[v.y][v.x]))+1,ddy[v.y+dy[i]]);
          d[v.y+dy[i]][v.x+dx[i]] = min(min(ddx[v.x],min(ddy[v.y],d[v.y][v.x]))+1,d[v.y+dy[i]][v.x+dx[i]]);
          q.push(mp(v.y+dy[i],v.x+dx[i]));
      }
    }
  }
  if (d[eny][enx] == inf && ddx[enx]==inf && ddy[eny]==inf){
    cout << "-1";
    return 0;
  }
  cout << min(ddx[enx],min(ddy[eny],d[eny][enx]));
  return 0;
}

