#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

//ifstream fin("stones.dat");
//ofstream fout("stones.sol");
FILE *fin = fopen( "stones.dat", "r" );
FILE *fout = fopen( "stones.sol", "w" );

inline const int left ( const int x ) { return 2 * x; }
inline const int right ( const int x ) { return 2 * x + 1; }
inline const int parent ( const int x ) { return x / 2; }
const int MAXM = int(2e5) + 42;
int n, m, _m;
pair < long, int > max_tree[4*MAXM];
set < long > min_town[MAXM];

void add(int heap, const long value ){
//    min_town[heap].insert( value );
    //if ( *min_town[heap].begin() != value ) return;
    int prt, curr = _m + heap;
    max_tree[curr] = make_pair( value, heap );
    while ( prt = parent(curr) ) {
        max_tree[prt] = max (
            max_tree[left(prt)],
            max_tree[right(prt)]
        );
		curr = prt;
    }
}
void del_top(){
    int town = max_tree[1].second;
    min_town[town].erase( min_town[town].begin() );
    if ( min_town[town].empty() ){
        add ( town, 0 );
    } else {
        add ( town, *min_town[town].begin() );
    }
}

int main(){

    fscanf( fin, "%d%d", &n, &m );
    for ( _m = 1; _m < m; _m *= 2);
    memset ( max_tree, 0, sizeof ( pair < long, int > ) * ( 2*_m + 1 ) );
    for ( int evt = 0; evt < n; ++evt ) {
        int type;
        fscanf ( fin, "%d", &type );
        if ( type == 1 ){
            int t;
            int w;
            fscanf(fin, "%d%d", &t, &w);
            min_town[t-1].insert( w );
            if ( *min_town[t-1].begin() == w ) {
                add ( t-1, w );
            }
        }else {
            fprintf ( fout, "%d\n", int(max_tree[1].first) );
            del_top();
        }
    }

    return 0;
}

