#include <cstdio>
#include <iostream>
#include <vector>
#include <list>
#include <set>

using namespace std;

typedef long long LL;

const LL INF = 1LL<<62;

vector < vector < LL > > g1;
vector < list < pair < int, LL > > > g2;
vector < set < int > > neighbours;
vector < LL > time_to;
set < pair < LL, int > > q;
FILE *fin = fopen("olympair.dat", "r");
FILE *fout = fopen("olympair.sol", "w");
int n,m;

void add ( int from, int to, LL time ){
    neighbours[from].insert ( to );
    g1[from][to] = min ( g1[from][to], time );
}

int main(){
    fscanf(fin, "%d %d\n", &n, &m);
    g1.resize(n,vector<LL>(n,INF));
    neighbours.resize(n);
    for ( int i = 0; i < m; ++i ){
        int type, a, b;
        LL c;
        fscanf(fin, "%d %d %d %lld\n", &type, &a, &b, &c);
        --a;--b;
        if ( type == 1 ){
            add ( a, b, c );
        }else{
            for ( set < int > :: iterator it = neighbours[a].begin(); it != neighbours[a].end(); ++it ){
                add ( b, *it, g1[a][*it]+c );
            }
        }
    }

    g2.resize(n);
    for ( int i = 0; i < n; ++i ){
        for ( set < int > :: iterator it = neighbours[i].begin(); it != neighbours[i].end(); ++it ){
            g2[i].push_back(make_pair(*it, g1[i][*it]));
        }
    }

    time_to.resize(n, INF);
    time_to[0] = 0;
    q.insert ( make_pair ( time_to[0], 0 ) );
    while ( !q.empty() ){
        int heap = q.begin()->second;
        q.erase ( q.begin() );
        LL time = time_to[heap];
        for ( list < pair < int, LL > > :: iterator it = g2[heap].begin(); it != g2[heap].end(); ++it ){
            if ( time_to[it->first] > time + it->second ){
                q.erase(make_pair ( time_to[it->first], it->first ));
                time_to[it->first] = time + it->second;
                q.insert(make_pair ( time_to[it->first], it->first ));
            }
        }
    }

    for ( int i = 1; i < n; ++ i){
        fprintf( fout, "%lld\n", (time_to[i] == INF)?-1:time_to[i]);
    }
    fclose ( fout );

    return 0;
}
