#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

ifstream fin("cap.dat");
ofstream fout("cap.sol");
typedef long long LL;
typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
template < typename T > const T sqr(const T x){return x*x;}
const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}

const int MAXN = 1042;
const char EMPTY = '.';
const char START = 'o';
const char USED = '&';
const char UNUSED = 'x';
const char FINISH = '+';
int n, m;

char a[MAXN][MAXN];

int main(){
    fin >> n >> m;
    for ( int i = 0; i <= n+1; ++i ){
        a[i][0] = a[i][m+1] = EMPTY;
    }
    for ( int j = 0; j <= m+1; ++j ){
        a[0][j] = a[n+1][j] = EMPTY;
    }
    int i0, j0;
    for ( int i = 1; i <= n; ++i){
        for ( int j = 1; j <= m; ++j ){
            fin >> a[i][j];
            if ( a[i][j] == START) {
                i0 = i;
                j0 = j;
            }
        }
    }

    queue < pair < int, pair < int, int > > > q;
    a[i0][j0] = USED;
    q.push ( make_pair ( 0, make_pair ( i0, j0 ) ) );
    while ( !q.empty() ){
        int cnt = q.front().first;
        int i0 = q.front().second.first;
        int j0 = q.front().second.second;
        q.pop();
        if ( a[i0][j0] == FINISH ){
            fout << cnt << endl;
            fout.close();
            return 0;
        }
        for ( int i = 1; i <= n; ++i ){
            if ( a[i][j0] == UNUSED ){
                a[i][j0] = USED;
                q.push(make_pair(cnt+1, make_pair(i, j0)));
            }else if ( a[i][j0] == FINISH ){
				fout << cnt+1 << endl;
				fout.close();
				return 0;
			}
		}
        for ( int j = 1; j <= m; ++j ){
            if ( a[i0][j] == UNUSED ){
                a[i0][j] = USED;
                q.push(make_pair(cnt+1, make_pair(i0, j)));
            } if ( a[i0][j] == FINISH ){
				fout << cnt+1 << endl;
				fout.close();
				return 0;
			}
        }
    }

    fout << -1 << endl;
    fout.close();
    return 0;
}
