#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

ifstream fin("tetris.dat");
ofstream fout("tetris.sol");
typedef long long LL;
typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
template < typename T > const T sqr(const T x){return x*x;}
const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}
vector < int > end_config;

inline void out(const int cnt){
    fout << cnt;
    exit(0);
}

int main(){
    int n;
    fin >> n;
    vector < int > begin_config(n);
    for ( int i = 0; i < n; ++i ){
        fin >> begin_config[i];
    }
    end_config.resize(n);
    for ( int i = 0; i < n; ++i ){
        fin >> end_config[i];
    }
    queue < pair < int, vector < int > > > q;
    map < vector < int >, bool > used;
    used[begin_config] = true;
    q.push(make_pair(0,begin_config));
    while ( !q.empty() ){
        int cnt = q.front().first;
        vector < int > current = q.front().second;
        q.pop();
        for ( int start = 0; start < n; ++start ){
            for ( int length = 1; length <= n-start; ++length ){
                current[start+length-1] = (current[start+length-1]+1)%4;
                if ( current == end_config ){
                    out(cnt+1);
                }else if (!used[current]){
                    used[current] = true;
                    q.push(make_pair(cnt+1, current));
                }
            }
            for ( int i = 0; i < n; ++i ){
                current[i] = (current[i]+4-1)%4;
            }
        }
    }
    return 0;
}
