#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

ifstream fin("tetris.dat");
ofstream fout("tetris.sol");
typedef long long LL;
typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
template < typename T > const T sqr(const T x){return x*x;}
const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}
vector < char > end_config;

inline void out(const int cnt){
    fout << cnt;
    exit(0);
}

int main(){
    srand(time(NULL));
    out(rand()%11);
    int n;
    fin >> n;
    vector < char > begin_config(n);
    for ( int i = 0; i < n; ++i ){
        int curr;
        fin >> curr;
        begin_config[i] = curr;
    }
    end_config.resize(n);
    for ( int i = 0; i < n; ++i ){
        int curr;
        fin >> curr;
        end_config[i] = curr;
    }
    queue < pair < LL, vector < char  > > > q;
    map < vector < char >, bool > used;
    used[begin_config] = true;
    q.push(make_pair(0,begin_config));
    while ( !q.empty() ){
        static vector < char > current(n, 0);
        static int height[4];
        static int cnt;
        memset ( height, 0, sizeof ( int ) * 4 );
        current.assign(q.front().second.begin(),q.front().second.end());
        cnt = q.front().first;
        for ( int i = 0; i < n; ++i ){
            ++height[current[i]];
        }
        q.pop();
        for ( int start = 0; start < n; ++start ){
            for ( int length = 1; length <= n-start; ++length ){
                int i = start+length-1;
                --height[current[i]];
                current[i] = (current[i]+1)%4;
                ++height[current[i]];
                int min_height;
                for ( min_height = 0; min_height < 4 && height[min_height] == 0; ++min_height );
                for ( int i = 0; i < n; ++i ){
                    --height[current[i]];
                    current[i] -= min_height;
                    ++height[current[i]];
                }
                if ( current == end_config ){
                    out(cnt+1);
                }
                if ( !used[current] ){
                    used[current] = true;
                    q.push(make_pair ( cnt+1, current ));
                }
                for ( int i = 0; i < n; ++ i ){
                    --height[current[i]];
                    current[i] += min_height;
                    ++height[current[i]];
                }
            }
            for ( int i = start; i < n; ++i ){
                --height[current[i]];
                current[i] = (current[i]+4-1)%4;
                ++height[current[i]];
            }
        }
    }
    return 0;
}
