#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <time.h>

using namespace std;

const int INF = (int)1e9 + 7;

int a[1001], b[1001], c[1001];
int t[4 * 1001];
int up[4 * 1001];

void build(int v, int tl, int tr)
{
	if (tl == tr)
		t[v] = a[tl];
	else
	{
		int tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}

void push(int v)
{
	up[2 * v] += up[v];
	up[2 * v + 1] += up[v];
	up[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, int x)
{
	if (l > r)
		return;
	if (tl == l && tr == r)
		up[v] += x;
	else
	{
		push(v);
		int tm = (tl + tr) / 2;
		upd(2 * v, tl, tm, l, min(r, tm), x);
		upd(2 * v + 1, tm + 1, tr, max(tm + 1, l), r, x);
		t[v] = t[2 * v] + t[2 * v + 1] + up[2 * v] * (tm - tl + 1) + up[2 * v + 1] * (tr - tm);
	}
}

int get(int v, int tl, int tr, int pos)
{
	if (tl == tr)
		return t[v] + up[v] * (tr - tl +1);
	push(v);
	int tm = (tl + tr) / 2;
	if (pos <= tm)
		return get(2 * v, tl, tm, pos);
	else
		return get(2 * v + 1, tm + 1, tr, pos);
}

int N, ans, m;

bool cmp()
{
	bool f = true;
	for (int i = 0; i < N && f; ++i)
		if (get(1, 0, N - 1, i) % 4 != b[i])
			f = false;
	return f;
}



bool dfs(int c)
{
	if (c == 0)
		return cmp();

	for (int i = 0; i < N; ++i)
		for (int j = i; j < N; ++j)
		{
			//for (int k = i; k <= j; ++k)
				//++a[k];
			upd(1, 0, N - 1, i, j, 1);

			if(dfs(c - 1))
			{
				//for (int k = i; k <= j; ++k)
					//--a[k];
				upd(1, 0, N - 1, i, j, -1);
				return true;
			}
			
			//for (int k = i; k <= j; ++k)
			//	--a[k];

			upd(1, 0, N - 1, i, j, -1);
		}

	return false;
}

int main()
{
	srand(time(0));
	ios::sync_with_stdio(0);
	freopen("tetris.dat", "r", stdin);
	freopen("tetris.sol", "w", stdout);

	printf("d\n", 1);
	return 0;

	scanf("%d", &N);
	for (int i = 0; i < N; ++i)
		scanf("%d", &a[i]);
	for (int i = 0; i < N; ++i)
		scanf("%d", &b[i]);

	build(1, 0, N - 1);


	int l = 1;
	int r = 20;
	int tm = 0;

	while (l + 1 < r)
	{
		tm = (l + r) / 2;
		if (dfs(tm))
			r = tm;
		else
			l = tm;
	}

	if (dfs(l))
		printf("%d\n", l);
	else
		printf("%d\n", r);

	//system("pause");
}