#include<cstdio>
#include<algorithm>
#include<set>

using namespace std;

typedef long long ll;

const int maxn=2001;
const ll INF = 2*1e18+2;
const ll inf = 1e18+2;
struct _edge{
	int fr, to;
	ll cost;
};

bool operator<(_edge a, _edge b){
	return (a.fr < b.fr)||(a.fr == b.fr && a.to < b.to);
}

bool operator==(_edge a, _edge b){
	return a.fr == b.fr && a.to == b.to;
}

ll G[maxn][maxn];
ll D[maxn];
_edge K[maxn];
int kl;
int n, m;

ll ms(ll a, ll b){
	if(a>b) a=b;
	return a;
}

int main(){
	freopen("olympair.dat","r",stdin);
	freopen("olympair.sol","w",stdout);
	scanf("%d%d", &n, &m);
	for(int i=1;i<=n;i++){
		for(int j=1; j<=n;j++)
			G[i][j] = INF;
		D[i] = INF;
	}
	int cfr, cto, t;
	ll ccost;
	_edge d, out;
	for(int i=1;i<=m;i++){
		scanf("%d%d%d%lld", &t,&cfr, &cto, &ccost);
		if(t==1){
			G[cfr][cto] = ms(G[cfr][cto], ccost);
			//printf("G[%d][%d] = %I64d %I64d\n",cfr,cto,G[cfr][cto], ccost);
		}
		else{
			for(int i=1; i<=n; i++)
				if(G[cfr][i]!=INF){
					//	printf("G[%d][%d] = %I64d %I64d\n", cto,i, G[cfr][i] + ccost, G[cfr][i]);
					G[cto][i] = ms(G[cfr][i] + ccost, G[cfr][i]);
					//printf("-> %I64d\n", G[cto][i]);
				}
		}
	}
	for(int i=1;i<=n; i++)
		for(int j=1;j<=n;j++) if(i!=j && G[i][j] !=INF){
			d.fr = i; d.to = j;
			d.cost = G[i][j];
			//printf("[%d %d]->%I64d\n",i,j,G[i][j]);
			K[++kl]= d;
		}
	bool any = true;
	D[1] = 0;
	while(any){
		any = false;
		for(int i=1;i<=n;i++){
			cfr = K[i].fr; cto = K[i].to; ccost = K[i].cost;
			if(D[cto] > D[cfr] + ccost){
				D[cto] = D[cfr] + ccost;
				any = true;
			}
		}
	}
	for(int i=2;i<=n;i++){
		if(D[i] > inf) printf("-1\n");
		else printf("%lld\n", D[i]);
	}
	return 0;
}
