#include <fstream>
#include <vector>
#include <list>

const int infinity = 1000*1000*1000;

bool check(const std::list<int>& genom,const std::vector<bool>& locked)
{
	if(genom.empty())
		return true;
	std::vector<bool> used(locked.size());
	std::list<int>::const_iterator previous = genom.begin();
	for(std::list<int>::const_iterator i = ++genom.begin();i != genom.end();i++)
	{
		if(locked[*i])
			continue;
		if(!used[*i])
			used[*i] = true;
		else
			if(*previous != *i)
				return false;
	}
	return true;
}

int through(const std::list<int>& current,std::vector<bool>& locked)
{
	if(check(current,locked))
		return 0;
	int answer = infinity;
	for(int i = 0;i < locked.size();i++)
	{
		if(locked[i])
			continue;
		std::list<int> temp = current;
		locked[i] = true;
		answer = std::min(answer,through(temp,locked) + 1);
		locked[i] = false;
	}
	return answer;
}

int main()
{
	std::ifstream in("mutation.dat");//fix
	int n;
	in >> n;
	std::list<int> genom;
	std::vector<bool> locked(n);
	for(int i = 0;i < n;i++)
	{
		int temp;
		in >> temp;
		genom.push_back(temp);
	}
	in.close();
	std::ofstream out("mutation.sol");
	out << through(genom,locked) << std::endl;
	out.close();
}
