#include <algorithm>
#include <fstream>
#include <numeric>
#include <vector>

bool check(const std::vector<int>& length,int n)
{
	int index = 0;
	int difference = length[n - 1] - length[0];
	for(int i = 1;i < length.size() - n + 1;i++)
	{
		if(length[i + n - 1] - length[i] < difference)
		{
			index = i;
			difference = length[i + n - 1] - length[i];
		}
	}
	return std::accumulate(length.begin() + index,length.begin() + n - 1,0) > length[n - 1];
}

int main()
{
	std::ifstream in("set.dat"); //fix
	std::ofstream out("set.sol");
	int n;
	in >> n;
	if(n < 3)
	{
		out << 0 << std::endl;
		in.close();
		out.close();
		return 0;
	}
	std::vector<int> length(n);
	for(int i = 0;i < length.size();i++)
		in >> length[i];
	in.close();
	std::sort(length.begin(),length.end());
	int leftBorder = 3;
	int rightBorder = length.size();
	while(leftBorder + 1 < rightBorder)
	{
		int middle = (leftBorder + rightBorder) / 2;
		if(check(length,middle))
			leftBorder = middle;
		else
			rightBorder = middle;
		if(leftBorder < 3)
			break;
	}
	int answer;
	if(check(length,rightBorder))
		answer = rightBorder;
	else if(check(length,leftBorder))
		answer = leftBorder;
	else
		answer = 0;
	out << answer << std::endl;
	out.close();
}