#include <fstream>
#include <vector>
#include <queue>
#include <list>

#include <cstring>

const int infinity = 1000*1000*1000;

const char startTag = 'o';
const char finishTag = '+';
const char emptyTag = '.';

int main()
{
	std::ifstream in("cap.dat"); // fix
	int n,m;
	in >> n >> m;
	char field[1000][1000];
	bool used[1000][1000];
	for(int i = 0;i < n;i++)
		for(int j = 0;j < m;j++)
			used[i][j] = false;
	std::pair<int,int> start,finish;
	for(int i = 0;i < n;i++)
	{
		for(int j = 0;j < m;j++)
		{
			in >> field[i][j];
			if(field[i][j] == startTag)
				start = std::make_pair(i,j);
			if(field[i][j] == finishTag)
				finish = std::make_pair(i,j);
		}
	}
	in.close();
	int distance[1000][1000];
	for(int i = 0;i < n;i++)
		for(int j = 0;j < m;j++)
			distance[i][j] = 0;
	std::queue<std::pair<int,int>,std::list<std::pair<int,int> > > queue;
	queue.push(start);
	distance[start.first][start.second] = 0;
	while(!queue.empty())
	{
		int x = queue.front().first;
		int y = queue.front().second;
		queue.pop();
		if(used[x][y] || field[x][y] == emptyTag)
			continue;
		used[x][y] = true;
		if(field[x][y] == finishTag)
			break;
		for(int i = 0;i < m;i++)
		{
			queue.push(std::make_pair(x,i));
			distance[x][i] = std::min(distance[x][i],distance[x][y] + 1);
		}
		for(int i = 0;i < n;i++)
		{
			queue.push(std::make_pair(i,y));
			distance[i][y] = std::min(distance[i][y],distance[x][y] + 1);
		}
	}
	std::ofstream out("cap.sol");
	out << (distance[finish.first][finish.second] != infinity ? distance[finish.first][finish.second] : -1) << std::endl;
	out.close();
}