#include <fstream>
#include <string>
#include <vector>
#include <queue>
#include <list>

#include <cstdio>

const int infinity = 1000*1000*1000;

const char startTag = 'o';
const char finishTag = '+';
const char emptyTag = '.';
const char usedTag = 'u';

int main()
{
//	std::ifstream in("cap.dat"); // fix
	int n,m;
	std::freopen("cap.dat","r",stdin);
	std::scanf("%d %d",&n,&m);
	char field[1000][1000];
	std::pair<int,int> start,finish;
	for(int i = 0;i < n;i++)
	{
		std::scanf("%s",&field[i][0]);
		for(int j = 0;j < m;j++)
		{
			if(field[i][j] == startTag)
				start = std::make_pair(i,j);
			if(field[i][j] == finishTag)
				finish = std::make_pair(i,j);
		}
	}
//	in.close();
	std::vector<std::vector<int> > distance(n,std::vector<int>(m,infinity));
	std::queue<std::pair<int,int>,std::list<std::pair<int,int> > > queue;
	queue.push(start);
	distance[start.first][start.second] = 0;
	while(!queue.empty())
	{
		int x = queue.front().first;
		int y = queue.front().second;
		queue.pop();
		if(field[x][y] == usedTag)
			continue;
		field[x][y] = usedTag;
		if(field[x][y] == finishTag)
			break;
		for(int i = 0;i < m;i++)
		{
			if(field[x][i] != emptyTag)
			{
				queue.push(std::make_pair(x,i));
				distance[x][i] = std::min(distance[x][i],distance[x][y] + 1);
			}
		}
		for(int i = 0;i < n;i++)
		{
			if(field[i][y] != emptyTag)
			{
				queue.push(std::make_pair(i,y));
				distance[i][y] = std::min(distance[i][y],distance[x][y] + 1);
			}
		}
	}
	std::ofstream out("cap.sol");
	out << (distance[finish.first][finish.second] != infinity ? distance[finish.first][finish.second] : -1) << std::endl;
	out.close();
}