#include <algorithm>
#include <fstream>
#include <vector>
#include <map>

const int infinity = 1000*1000*1000;

void inc(std::vector<int>& v)
{
	int i;
	for(i = 0;i < v.size() && v[i] == 3;i++)
		v[i] = 0;
	v[i]++;
}

void through(std::map<std::vector<int>,int>& table,int n)
{
	std::vector<int> current(n);
	std::vector<int> last(n,3);
	for(;current < last;inc(current))
	for(int begin = 0;begin < n;begin++)
	{
		for(int end = begin + 1;end <= n;end++)
		{
			std::vector<int> next(n);
			for(int k = begin;k < end;k++)
				next[k] = (current[k] + 1) % 4;
			if(table.find(next) == table.end())
				table[next] = table[current] + 1;
			else
				table[next] = std::min(table[next],table[current] + 1);
		}
	}
}

int main()
{
	std::ifstream in("tetris.dat"); // fix
	std::ofstream out("tetris.sol");
	int n;
	in >> n;
	std::vector<int> column(n);
	for(int i = 0;i < column.size();i++)
	{
		int temp;
		in >> temp;
		column[i] = 4 - temp;
	}
	for(int i = 0;i < column.size();i++)
	{
		int temp;
		in >> temp;
		column[i] += temp;
		column[i] %= 4;
	}
	in.close();
	if(n <= 8)
	{
		std::map<std::vector<int>,int> table;
		through(table,n);
		int answer = 0;
		out << table[column] << std::endl;
	}
	out.close();
}