#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <string>
#include <cstring>
#include <algorithm>
#include <utility>
#include <functional>
#include <stack>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;


#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pdd pair<double,double>

const ll inf = 1e18;

struct vect{
	int x,y;
	vect( int x1 = 0, int y1 = 0, int x2 = 0, int y2 = 0 ):x(x2-x1),y(y2-y1){}
};


const int MXN = 100100;
const int MXE = 1000100;

struct edge{
	int to;
	ll c;
	edge( int a = 0, int b = 0, ll c = 0 ):to(b),c(c){}
};

edge eds [MXE];
int head [MXN];
int nxt [MXE];
int edc = 0;
ll dst [MXN];
int ok [MXN];

void adde( int a, int b, ll c ){
//	if( edc>=MXE ) for(;;);
	nxt[edc] = head[a];
	head[a] = edc;
	eds[edc++] = edge(a,b,c);
}

int n,m;
void cdst( int v ){
	set< pair<ll,int> > cur;
	for( int i = 1; i < n; i++ ){
		cur.insert( mp(inf,i) );
		dst[i] = inf;
	}

	cur.insert( mp(0,0) );
	dst[0] = 0;

	while( !cur.empty() ){
		pair<ll,int> q = *cur.begin();
		ok[q.second] = 1;

		cur.erase(cur.begin());
		if(q.first==inf) continue;

		int ee = head[q.second];

		while( ee!=-1 ){
			//ee
			edge ced = eds[ee];
			if( !ok[ced.to] ){
				//to && fr
				if( dst[ced.to] > dst[q.second] + ced.c ){
					cur.erase( mp(dst[ced.to],ced.to) );
					dst[ced.to] = dst[q.second] + ced.c;
					cur.insert( mp(dst[ced.to],ced.to) );
				}
			}
			ee = nxt[ee];
		}
	}
}

ll ed [2010][2010];

void solve1(){//
	for( int i = 0; i < n; i++ )
		for( int j = 0; j < n; j++ )
			ed[i][j] = inf;

	int a,b,c,t;
	for( int i = 0; i < m; i++ ){
		scanf("%d%d%d%d", &t, &a, &b, &c);
		a--,b--;
		if(t==2){
			for( int i = 0; i < n; i++ )
				if( ed[a][i] < inf )
					ed[b][i] = min( ed[b][i], ed[a][i] + c );
		}
		else
			ed[a][b] = min( ed[a][b], ll(c) );
	}

	for( int i = 0; i < n; i++ ) dst[i] = inf;
	dst[0] = 0;

	for( int i = 0; i < n; i++ ){
		int v = -1; ll bst = inf+1;
		for( int j = 0; j < n; j++ ){
			if( ok[j] ) continue;
			if( bst>dst[j] ){
				bst = dst[j];
				v = j;
			}
		}

		ok[v] = 1;
		if( dst[v]==inf ) continue;
		for( int i = 0; i < n; i++ )
			if( ed[v][i] < inf )
				dst[i] = min(dst[i], ed[v][i] + dst[v] );
	}
}
void solve2(){
	for( int i = 0; i < n; i++ ) head[i] = -1;

	int a,b,c,t;
	for( int i = 0; i < m; i++ ){
		scanf("%d%d%d%d", &t, &a, &b, &c);

		a--,b--;
		if(t-1){
			int ee = head[a];
			while(ee!=-1){
				//ee
				adde(b,eds[ee].to, eds[ee].c + c);
				ee = nxt[ee];
			}
		}
		else{
			adde(a,b,c);
		}
	}
	
	cdst(0);

}
void solve3(){
	for( int i = 0; i < n; i++ ) head[i] = -1;

	int a,b,c,t;
	for( int i = 0; i < m; i++ ){
		scanf("%d%d%d%d", &t, &a, &b, &c);

		a--,b--;
		if(t-1){
			//addes(a,b,c);
		}
		else{
			adde(a,b,c);
		}
	}
	
	cdst(0);
}

int main(){/////
	freopen("olympair.dat", "r", stdin);	freopen("olympair.sol", "w", stdout);
	clock_t st = clock();
	scanf("%d%d", &n, &m);

//	solve3();
	
	if( n<=2000 && m<=4000 ){
		solve1();
	}
	else solve2();

	
	clock_t end = clock();


	for( int i = 1; i < n; i++ ){
		printf("%d\n", dst[i]==inf ? -1 : dst[i]);
	} 
//	cout<<endl<<double(end-st)/CLOCKS_PER_SEC;
}
