#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
typedef long long ll;
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))
#define INF 2000000000000000000ll
using namespace std;

int n;
vector< pair<int, ll> > g[200001];
int like[200001], lsz[200001], ls;
ll add[200001];


priority_queue< pair<ll, int> > md;
ll d[200001];
bool used[200001];
void dkstr()
{
	for (int i = 1; i < ls; i++)
		d[i] = INF, md.push(make_pair(-INF, i)), used[i] = false;
	d[0] = 0, md.push(make_pair(0, 0)), used[0] = false;
	while (!md.empty())
	{
		pair<ll, int> best = md.top();
		md.pop();
		if (used[best.second])
			continue;

		int v = best.second;
		ll w = -best.first;
		int rv, sz;
		ll tadd;

		used[v] = true;

		if (v < n)
			rv = v, sz = g[v].size(), tadd = 0;
		else
			rv = like[v], sz = lsz[v], tadd = add[v];

		for (int j = 0; j < sz; j++)
		{
			int to = g[rv][j].first;
			ll w = g[rv][j].second + tadd;
			pair<ll,int> bf;
			if (d[to] > d[v] + w)
			{
				d[to] = d[v] + w;
				bf.second = to;
				bf.first = -d[to];
				md.push(bf);
			}
		}
	}
}

void belfrd()
{
	for (int i = 1; i < ls; i++)
		d[i] = INF;
	d[0] = 0;
	for (int i = 0; i < ls; i++)
	{
		for (int v = 0; v < ls; v++)
		{
			int rv, sz;
			if (v < n)
				rv = v, sz = g[v].size();
			else
				rv = like[v], sz = lsz[v];

			for (int j = 0; j < sz; j++)
				if (d[g[rv][j].first] > d[v] + g[rv][j].second)
					d[g[rv][j].first] = d[v] + g[rv][j].second;
		}
	}
}

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);

	
	int m;
	bool neg = false;
	scanf("%d%d", &n, &m);

	
	ls = n;

	for (int i = 0; i < m; i++)
	{
		int t, a, b, c;
		scanf("%d%d%d%d", &t, &a, &b, &c);
		a--, b--;
		if (c < 0)
			neg = true;
		if (t == 1)
			g[a].push_back(make_pair(b,c));
		else
		{
			g[b].push_back(make_pair(ls, 0));

			like[ls] = a;
			add[ls] = c;
			lsz[ls] = g[a].size();
			ls++;
		}
	}

//	if (neg)
//		belfrd();
//	else
		dkstr();

	for (int i = 1; i < n; i++)
	{
		if (d[i] >= INF)
			printf("-1\n");
		else
			printf("%Ld\n", d[i]);
	}

	return 0;
}